#include <string.h>
#include "create.h"
#include <memory.h>
#include <stdio.h>
#include <fcntl.h>
#include "pe.h"
#include "stuff.h"
#include "list.h"
#include <io.h>
#include "append.h"
#define TMP_FILE "$tmp$"
int CreateImportsInc(PeHeader *PE,const char *targetf, const char* equf);
int CreateExportsInc(PeHeader *PE,const char *targetf, const char* equf2);

int _appendfile(const char* targetf, const char* sourcef, uint32 pos,uint32 FSize);
//=============================================================================

int AppendToPe(const char* targetf, const char* sourcef, const char* equf, const char* equf2, uint32 Method)
{
PeHeader 	PE;
int 		SHan; 
uint i;

uint32 SLen,AppPos,AppRva;

IMAGE_OPTIONAL_HEADER *OptHeader;
IMAGE_FILE_HEADER     *FileHeader;
IMAGE_SECTION_HEADER  *SecHeader;
IMAGE_SECTION_HEADER   AppSectionHeader;
IMAGE_DATA_DIRECTORY  *Dir;

uint32 FAlign,SAlign,SecNum;

/*
 * Load PE header...
 */
//=============================================================================

if (PE.LoadHeader(targetf)==-1){
                              printf("ERROR:%s\n",PE.GetLastErrorText());
                              return -1;
                                };

/* 
 * Get headers pointers
 */
//=============================================================================

OptHeader=PE.GetOptionalHeader();
FileHeader=PE.GetFileHeader();

if(OptHeader==NULL||FileHeader==NULL)return -1;

/*
 * Get File & Section alignment, Number of sections
 */
//=============================================================================

FAlign=OptHeader->FileAlignment;
SAlign=OptHeader->SectionAlignment;
SecNum=FileHeader->NumberOfSections;

if (Method&0x80)
	{
	uint32 LastRaw=0,DecSize;
	int TmpHan;
	for(i=0;i<SecNum;i++){
		SecHeader=PE.GetSectionHeader(i);
          	if(SecHeader==NULL)return -1;
		if((SecHeader->PointerToRawData)>LastRaw)LastRaw=SecHeader->PointerToRawData;
		}
	if((SecHeader->PointerToRawData)!=LastRaw){printf("Logical last section is not phys. last\n");return -1;}
	DecSize=(SecHeader->Misc.VirtualSize>SecHeader->SizeOfRawData)?SecHeader->Misc.VirtualSize:SecHeader->SizeOfRawData;
	OptHeader->SizeOfImage-=DecSize;
	PE.PopSectionHeader();
	if(PE.SaveHeader(targetf)==-1){printf("Can't save header.\n");return -1;}
	TmpHan=open(targetf,O_RDWR|O_BINARY);
	if(TmpHan==-1){printf("Can't resize file\n");return -1;}
	_chsize(TmpHan,LastRaw);
	close(TmpHan);

if (PE.LoadHeader(targetf)==-1){
                              printf("ERROR:%s\n",PE.GetLastErrorText());
                              return -1;
                                };
	OptHeader=PE.GetOptionalHeader();
	FileHeader=PE.GetFileHeader();

	if(OptHeader==NULL||FileHeader==NULL)return -1;
	FAlign=OptHeader->FileAlignment;
	SAlign=OptHeader->SectionAlignment;
	SecNum=FileHeader->NumberOfSections;
	}

if (Method&0x2){
for (i=0;i<SecNum;i++)
	{
	SecHeader=PE.GetSectionHeader(i);
	SecHeader->Characteristics|=0xe0000000;
	}
}

if(sourcef){
/*
 * Check, if we have space for more one section header
 */
//=============================================================================
if(Method&0x1){
if(((OptHeader->SizeOfHeaders)-PE.GetRealSizeOfHeaders())<
    sizeof(IMAGE_SECTION_HEADER))
                                 {
			printf ("ERROR: No space for extra section header!\n");
			return -1;
                                 }
}

/*
 * Get last section header
 */
//=============================================================================


SecHeader=PE.GetSectionHeader(SecNum-1);

/* 
 * Calculate RVA and RawPointer to append data
 * according File and Section Alignment
 */
//=============================================================================

if (Method&0x1){  /* if method say us to create new section */
	AppPos=SecHeader->PointerToRawData+SecHeader->SizeOfRawData;
	AppPos+=MOD(AppPos,FAlign);
	AppRva=SecHeader->VirtualAddress+
				(((SecHeader->Misc.VirtualSize)>(SecHeader->SizeOfRawData))?
				SecHeader->Misc.VirtualSize:SecHeader->SizeOfRawData);
	AppRva+=MOD(AppRva,SAlign);
		} 
else {		 /* else, resize last section */
	AppPos=SecHeader->PointerToRawData; /* if uninit data, we cant resize it */
	if (!AppPos){ printf("ERROR! Can't resize BSS section.\n");return -1;}
	AppPos+=(((SecHeader->Misc.VirtualSize)>(SecHeader->SizeOfRawData))?
				SecHeader->Misc.VirtualSize:SecHeader->SizeOfRawData);
	AppRva=AppPos-(SecHeader->PointerToRawData)+
		   SecHeader->VirtualAddress;
}	
             
		}

if(Method&0x40){
printf(" * Generating Imports file '%s'\n",equf);
if(CreateImportsInc(&PE,targetf,equf)==-1)printf("Cant't generate!");
		}
if(Method&0x20){
printf(" * Generating Exports file '%s'\n",equf2);
if(CreateExportsInc(&PE,targetf,equf2)==-1)printf("Can't generate!");
	}

/*
 * Create source file to be appended
 */
uint32 RelocsRVA;
Dir=PE.GetDirectory(IMAGE_DIRECTORY_ENTRY_BASERELOC);

if (!Dir)RelocsRVA=0;
else {RelocsRVA=Dir->VirtualAddress;if(Method&0x4){Dir->VirtualAddress=0;Dir->Size=0;}}

int32 FSize;

if(sourcef){

//=============================================================================
if (Create(TMP_FILE,sourcef,AppRva,OptHeader->ImageBase,
               OptHeader->AddressOfEntryPoint,RelocsRVA,RelocsRVA!=NULL,(Method&0x10)>>4))
     {
      printf("Error creating stub...\n");
      return -1;   
     }             
/*
 * Get size of append file...
 */
//=============================================================================

SHan=open(TMP_FILE,O_RDONLY|O_BINARY);
	if (SHan==-1)return -1;
	SLen=filelength(SHan);
	if (SLen==-1)return -1;
close(SHan);

/* 
 * Fill our new section fields
 */
//=============================================================================


if (Method&0x1){ /* for new section */

	memcpy(AppSectionHeader.Name,".append",8);
	AppSectionHeader.Misc.VirtualSize=SLen+MOD(SLen+AppRva,SAlign);
	AppSectionHeader.VirtualAddress=AppRva;
	AppSectionHeader.SizeOfRawData=SLen+MOD(SLen+AppPos,FAlign);
	AppSectionHeader.PointerToRawData=AppPos;
	AppSectionHeader.Characteristics=0xE0000020; //code & data 
	AppSectionHeader.PointerToRelocations=0;
	AppSectionHeader.PointerToLinenumbers=0;
	AppSectionHeader.NumberOfRelocations=0;
	AppSectionHeader.NumberOfLinenumbers=0;

if(!(Method&0x10))OptHeader->AddressOfEntryPoint=AppRva; //Start of code point

	OptHeader->SizeOfCode+=AppSectionHeader.Misc.VirtualSize;
	OptHeader->SizeOfImage+=AppSectionHeader.Misc.VirtualSize;
	OptHeader->SizeOfInitializedData+=AppSectionHeader.Misc.VirtualSize;
	FSize=AppSectionHeader.PointerToRawData+AppSectionHeader.SizeOfRawData;
/*
 * Add section to header and save it...
 */
//=============================================================================

	if (PE.PushSectionHeader(&AppSectionHeader)==-1)return -1;
}

else {        /* if resize last section */
	uint32 OldVS=SecHeader->Misc.VirtualSize;
	if(SecHeader->Misc.VirtualSize)SecHeader->Misc.VirtualSize+=SLen;

	SecHeader->SizeOfRawData=AppPos-(SecHeader->PointerToRawData)+SLen;
	SecHeader->SizeOfRawData+=MOD(SecHeader->SizeOfRawData,FAlign);
	SecHeader->Characteristics=((SecHeader->Characteristics)&0xffffff00)|0xE0000020;

if(!(Method&0x10))OptHeader->AddressOfEntryPoint=AppRva;                 //Start of code point

	OptHeader->SizeOfCode+=OldVS;
	OptHeader->SizeOfImage=
		(SecHeader->VirtualAddress+SecHeader->Misc.VirtualSize>
		 SecHeader->VirtualAddress+SecHeader->SizeOfRawData) ?
		 SecHeader->VirtualAddress+SecHeader->Misc.VirtualSize:
	     SecHeader->VirtualAddress+SecHeader->SizeOfRawData;

	FSize=SecHeader->PointerToRawData+SecHeader->SizeOfRawData;
}

        }

	if (PE.SaveHeader(targetf)==-1)return -1;

/*
 * append file...
 */
//=============================================================================
if(sourcef){
if (_appendfile(targetf,TMP_FILE,AppPos,FSize)==-1){
                           printf("ERROR: Can't append file...\n");
                           return -1;
                           }  
	   }
return 0;

}

#define COPY_BUFF_SIZE 0x8000


//=============================================================================

int _appendfile(const char* targetf, const char* sourcef, uint32 pos, uint32 Size)
{

int hana,hanb;
uint32 i,FSize;

char *buff=new char[COPY_BUFF_SIZE];
if(buff==NULL)return -1;

hana=open(targetf,O_WRONLY|O_BINARY);
if (hana==-1)return -1;
if (lseek(hana,pos,SEEK_SET)==-1)return -1;
hanb=open(sourcef,O_RDONLY|O_BINARY);
if (hanb==-1)return -1;
FSize=filelength(hanb);
if (FSize==-1)return -1;
if (lseek(hanb,0,SEEK_SET)==-1)return -1;
for (i=0;i<FSize/COPY_BUFF_SIZE;i++)
         {
         if (read(hanb,buff,COPY_BUFF_SIZE)==-1)return -1;
         if (write(hana,buff,COPY_BUFF_SIZE)==-1)return -1;
         } 
if (read(hanb,buff,FSize%COPY_BUFF_SIZE)==-1)return -1;
if (write(hana,buff,FSize%COPY_BUFF_SIZE)==-1)return -1;
if ((pos+FSize)<Size)
{
	if (lseek (hana,Size-1,SEEK_SET)==-1)return -1;
	if (write (hana,&i,1)==-1)return -1;
}
close (hana);
close (hanb);
return 0;
}

//=============================================================================
int FixCheckSum(char* name)
{
PeHeader 	PE;
IMAGE_OPTIONAL_HEADER *OptHeader;
DWORD OldCheckSum;
DWORD NewCheckSum;
ULONG Result;
Result=MapFileAndCheckSumA(name,&OldCheckSum,&NewCheckSum);
if (Result)return -1;
if (PE.LoadHeader(name)==-1){
                              printf("ERROR:%s\n",PE.GetLastErrorText());
                              return -1;
                                };
OptHeader=PE.GetOptionalHeader();
OptHeader->CheckSum=NewCheckSum;
if (OptHeader==NULL)return -1;
if (PE.SaveHeader(name)==-1)return -1;
printf("(%#x->%#x)\n",OldCheckSum,NewCheckSum);
return 0;
}

//==============================================================================
int CreateExportsInc(PeHeader *PE,const char *targetf, const char* equf2)
{
char name[256];
uint32 Addr;
int SHan;
IMAGE_DATA_DIRECTORY  *Dir;
char *buff = new char[1024];
int k;char *ptr;
int i;
Dir=PE->GetDirectory(IMAGE_DIRECTORY_ENTRY_EXPORT);
uint32 ExportsRVA=Dir->VirtualAddress;
if(ExportsRVA){

uint8* Exports= new uint8[Dir->Size];
List ExportedNames;

if((!Exports)||(!buff))return -1;

uint32 ExpLseek=PE->Rva2Lseek(Dir->VirtualAddress);
uint32 ExpRva=Dir->VirtualAddress;

IMAGE_EXPORT_DIRECTORY *IED;

SHan=open(targetf,O_RDONLY|O_BINARY); // open target file
uint Expf=open(equf2,O_CREAT|O_BINARY|O_WRONLY|O_TRUNC,-1);

if (SHan==-1||Expf==-1)return -1;

sprintf (buff,"\n; Export table RVAs.\n\n");
if (write(Expf,buff,strlen(buff))==-1)return -1;

if (lseek(SHan,ExpLseek,SEEK_SET)==-1)return -1;
if (read(SHan,Exports,Dir->Size)==-1)return -1;

IED=(IMAGE_EXPORT_DIRECTORY *)Exports;
uint32 *NameAddr=(uint32*)new uint32 [IED->NumberOfNames];
if (lseek(SHan,PE->Rva2Lseek(IED->AddressOfNames),SEEK_SET)==-1)return -1;
if (read(SHan,NameAddr,(IED->NumberOfNames)*4)==-1)return -1;

uint16 *NameOrd=(uint16*)new uint16 [IED->NumberOfFunctions];
if (lseek(SHan,PE->Rva2Lseek(IED->AddressOfNameOrdinals),SEEK_SET)==-1)return -1;
if (read(SHan,NameOrd,(IED->NumberOfFunctions)*2)==-1)return -1;

uint32 *FuncAddr=(uint32*) new uint32[IED->NumberOfFunctions];
if (lseek(SHan,PE->Rva2Lseek(IED->AddressOfFunctions),SEEK_SET)==-1)return -1;
if (read(SHan,FuncAddr,(IED->NumberOfFunctions)*4)==-1)return -1;

for(k=0;k<IED->NumberOfNames;k++)
	{
	if (lseek(SHan,PE->Rva2Lseek(NameAddr[k]),SEEK_SET)==-1)return -1;
	i=0;
	while(1){					// get function name
			if (i>255)return -1;
			if (read(SHan,&name[i],1)==-1)return -1;	
			if (!name[i++])break;
			}
	ptr=(char*) new char[strlen(name)+1];
	strcpy(ptr,name);
	if(ExportedNames.Add(ptr)==-1)return -1;
	}

for(k=0;k<IED->NumberOfNames;k++)
	{
	ptr=(char*)ExportedNames.Get(k);
	Addr=FuncAddr[NameOrd[k]];
        sprintf (buff,"%-32s\tequ\t%.8xh\n",ptr,Addr);
	if (write(Expf,buff,strlen(buff))==-1)return -1;
	}
delete Exports;
delete buff;
delete NameAddr;
delete NameOrd;
delete FuncAddr;
ExportedNames.DestroyAll();
close (SHan);
close (Expf);
		}
return 0;
}
//==============================================================================
int CreateImportsInc(PeHeader *PE,const char *targetf, const char* equf)
{
int SHan;
IMAGE_DATA_DIRECTORY  *Dir;
int i;

Dir=PE->GetDirectory(IMAGE_DIRECTORY_ENTRY_IMPORT);
uint32 ImportsRVA=Dir->VirtualAddress;
char *buff = new char[1024];
uint32 Addr; char name[256];
if(ImportsRVA){

uint8* Imports= new uint8[Dir->Size];


if((!Imports)||(!buff))return -1;

uint32 ImpLseek=PE->Rva2Lseek(Dir->VirtualAddress);
uint32 ImpRva=Dir->VirtualAddress;
uint32 tmp_d;

IMAGE_IMPORT_DESCRIPTOR *IID;
 uint n;

SHan=open(targetf,O_RDONLY|O_BINARY); // open target file
uint Impf=open(equf,O_CREAT|O_BINARY|O_WRONLY|O_TRUNC,-1);

if (SHan==-1||Impf==-1)return -1;

sprintf (buff,"\n; Import table RVAs.\n\n");
if (write(Impf,buff,strlen(buff))==-1)return -1;

if (lseek(SHan,ImpLseek,SEEK_SET)==-1)return -1;
if (read(SHan,Imports,Dir->Size)==-1)return -1;

IID=(IMAGE_IMPORT_DESCRIPTOR *)Imports;

while(IID->FirstThunk)
	{
	n=0;							// num of imports
	Addr=IID->OriginalFirstThunk;
	while(1)
		{
		if (lseek(SHan,PE->Rva2Lseek(Addr),SEEK_SET)==-1)return -1;
		if (read(SHan,&tmp_d,sizeof(uint32))==-1)return -1; 
		if (!tmp_d)break;
		if (lseek(SHan,PE->Rva2Lseek(tmp_d)+2,SEEK_SET)==-1)return -1;
		i=0; 
		while(1){					// get function name
				if (i>255)return -1;
				if (read(SHan,&name[i],1)==-1)return -1;	
				if (!name[i++])break;
				}
		sprintf (buff,"%-32s\tequ\t%.8xh\n",name,(IID->FirstThunk)+n*sizeof(uint32));
		if (write(Impf,buff,strlen(buff))==-1)return -1;
		//printf("%s-%#x\n",name,(IID->FirstThunk)+n*sizeof(uint32));
		Addr+=sizeof(uint32);
		n++;
		}
	IID++;
	}

delete Imports;
delete buff;
close (SHan);
close (Impf);
        	}
return 0;
}