#include "list.h"
#include <memory.h>
#include <stdio.h>
#include <fcntl.h>
#include "pe.h"
#include "stuff.h"
#include <io.h>

#define SIZE_OF_CODE_PART 116

char PreInitCode[116]={

0xfc,0xe8,0,0,0,0,0x5b,0x81,0xeb,0x6,0,0,
0,0x8b,0xeb,0x2b,0xab,0x74,0,0,0,0x2b,0xab,0x7c,
0,0,0,0x1,0xab,0x7c,0,0,0,0x1,0xab,0x80,
0,0,0,0x1,0xab,0x84,0,0,0,0x8b,0x8b,0x88,
0,0,0,0x8b,0xf3,0x81,0xc6,0x8c,0,0,0,0x8b,
0xd1,0xd1,0xe2,0x3,0xd6,0xe3,0xb,0x8b,0xfa,0x33,0xc0,0x66,
0xad,0x1,0x2c,0x7,0xe2,0xf9,0x53,0xff,0xb3,0x80,0,0,
0,0x55,0xff,0xb3,0x7c,0,0,0,0xb8,0x6c,0,0,
0,0x3,0xc3,0x50,0x3,0x93,0x78,0,0,0,0x52,0xc3,
0x5b,0xff,0xb3,0x84,0,0,0,0xc3};

struct FormatDataPart{
uint32 RvaOfInit;
uint32 InitEntryPointOffset;
uint32 BaseOfImage;
uint32 BaseOfRelocs;
uint32 EntryPoint;
uint32 NumOfFixups;
uint16 FixupTable[1];
}; 
#define SIZEOF_FORMAT 6*4
int Create(const char* targetf, const char* sourcef, uint32 TargetRVA,
                                uint32 TargetBase, uint32 TargetEP,
                                uint32 TargetRelocs,
                                uint do_relocs,uint NoEp)
{
PeHeader 	PE;
int 		SHan; 
uint i,k;

uint32 SLen,AppPos,AppRva,SourceBase;

IMAGE_OPTIONAL_HEADER *OptHeader;
IMAGE_FILE_HEADER     *FileHeader;
IMAGE_SECTION_HEADER  *SecHeader;

uint32 FAlign,SAlign,SecNum,EntryPoint;

TargetEP+=TargetBase;
//TargetRelocs+=TargetBase;
/*
 * Load PE header...
 */
if (PE.LoadHeader(sourcef)==-1){
                              printf("ERROR:%s\n",PE.GetLastErrorText());
                              return -1;
                                };
/* 
 * Get headers pointers
 */

OptHeader=PE.GetOptionalHeader();
FileHeader=PE.GetFileHeader();

if(OptHeader==NULL||FileHeader==NULL)return -1;

/*
 * Get File & Section alignment, Number of sections
 */

FAlign=OptHeader->FileAlignment;
SAlign=OptHeader->SectionAlignment;
SecNum=FileHeader->NumberOfSections;
EntryPoint=OptHeader->AddressOfEntryPoint;
SourceBase=OptHeader->ImageBase;

/*
 * Looking for section, where EP lies..
 */

IMAGE_SECTION_HEADER *BaseSec=NULL;

for(i=0;i<SecNum;i++)
	{
         SecHeader=PE.GetSectionHeader(i);
         if((SecHeader->VirtualAddress)>EntryPoint ||
            (SecHeader->VirtualAddress+SecHeader->SizeOfRawData)<EntryPoint)
               continue;
        BaseSec=SecHeader;
        }
if(BaseSec==NULL)return -1;

/*
 * Now get relocations...
 */

uint32 Size;
uint8 *buff;
List RelocsOffs;
uint32 *pRVA;

IMAGE_DATA_DIRECTORY *RelocDir;

RelocDir=PE.GetDirectory(IMAGE_DIRECTORY_ENTRY_BASERELOC);
if(RelocDir->VirtualAddress){/* DO RELOCS!!! */
                                

/*
 * Loading relocations...
 */

Size=RelocDir->Size+sizeof(IMAGE_BASE_RELOCATION);
buff=new uint8[Size];
if(!buff)return -1;
memset(buff,0,Size);
SHan=open(sourcef,O_RDONLY|O_BINARY);
if (lseek(SHan,PE.Rva2Lseek(RelocDir->VirtualAddress),SEEK_SET)==-1)return -1;
if (read(SHan,buff,RelocDir->Size)==-1)return -1;
close(SHan);

/*
 * Build Relocs in format dd <offset from base section>...
 */

uint16 *word_ptr;
uint16 Reloc;
IMAGE_BASE_RELOCATION *BaseRelocs=(IMAGE_BASE_RELOCATION*)buff;

while(BaseRelocs->VirtualAddress)
       {
       if ( (BaseRelocs->VirtualAddress > BaseSec->VirtualAddress +BaseSec->SizeOfRawData) ||  
            (BaseRelocs->VirtualAddress+0x1000 < BaseSec->VirtualAddress))
                  {
                  BaseRelocs=(IMAGE_BASE_RELOCATION*)((uint8*)BaseRelocs+BaseRelocs->SizeOfBlock);
                  continue;
                  }
        k=(BaseRelocs->SizeOfBlock-sizeof(IMAGE_BASE_RELOCATION))/2;
        word_ptr=(uint16*)((uint8*)BaseRelocs+sizeof(IMAGE_BASE_RELOCATION));
        for(i=0;i<k;i++)
               {
               Reloc=word_ptr[i];
               switch(Reloc&0xf000)  
                 {
               case 0:
                 continue;
               case 0x3000:
                 // only this type supported
                 pRVA=new uint32;
                 *pRVA=(BaseRelocs->VirtualAddress) + (Reloc&0xfff); 
                 *pRVA=(*pRVA)-(BaseSec->VirtualAddress);
                 if(RelocsOffs.Add(pRVA)==-1)return -1;
                 break;
               default:
                 return -1;
                 } 
               }  
       BaseRelocs=(IMAGE_BASE_RELOCATION*)((uint8*)BaseRelocs+BaseRelocs->SizeOfBlock);
       } 

delete buff;
                                         }/* end relocs */
else {printf ("Warning! No relocs!\n");do_relocs=0;}
/*
 * Load and fix init rtne
 */

uint32 delta=TargetBase-SourceBase-(BaseSec->VirtualAddress)+TargetRVA;
FormatDataPart* PreInitData;

if(!NoEp){
delta+=SIZEOF_FORMAT+SIZE_OF_CODE_PART;
delta+=do_relocs*RelocsOffs.GetNum()*sizeof(uint16);

k=SIZEOF_FORMAT+do_relocs*RelocsOffs.GetNum()*sizeof(uint16);
PreInitData=(FormatDataPart*) new char[k];
if (!PreInitData)return -1;
         }

buff=new uint8 [BaseSec->SizeOfRawData];

if (!buff)return -1;

SHan=open(sourcef,O_RDONLY|O_BINARY);
lseek(SHan,BaseSec->PointerToRawData,SEEK_SET);
read(SHan,buff,BaseSec->SizeOfRawData);
close(SHan);

for(i=0;i<RelocsOffs.GetNum();i++)
 {
 pRVA=(uint32*)RelocsOffs.Get(i);
 if (!pRVA)return -1;
 *((uint32*)(&buff[*pRVA]))+=delta;
 if(do_relocs&&(!NoEp))PreInitData->FixupTable[i]=(*pRVA);
 }

/*
 * Fill PreInitData fields
 */
if(!NoEp){
PreInitData->RvaOfInit=TargetRVA;
PreInitData->InitEntryPointOffset=EntryPoint-BaseSec->VirtualAddress;
PreInitData->BaseOfImage=TargetBase;
PreInitData->BaseOfRelocs=TargetRelocs;
PreInitData->EntryPoint=TargetEP;
PreInitData->NumOfFixups=do_relocs*RelocsOffs.GetNum();
          }
printf(" * Total %u reloc(s) in source\n",RelocsOffs.GetNum());

/*
 * Write result file...
 */
int THan=open(targetf,O_CREAT|O_TRUNC|O_BINARY|O_WRONLY,-1);
if (THan==-1)return -1;
if(!NoEp){
if (write(THan,PreInitCode,SIZE_OF_CODE_PART)==-1)return -1;
if (write(THan,PreInitData,k)==-1)return -1;
         }
if (write(THan,buff,BaseSec->SizeOfRawData)==-1)return -1;
delete buff;
if(!NoEp)delete PreInitData;
close (THan);
return 0;
}

