#ifndef _PE_ANALYS_H_INCLUDED
#define _PE_ANALYS_H_INCLUDED

#include "winnt.h"

enum _PeHeaderError {UNDEF, FILE_IO, MEMORY, PE_FORMAT};

class PeHeader {
IMAGE_DOS_HEADER	MzHeader;
IMAGE_FILE_HEADER 	FileHeader;
IMAGE_OPTIONAL_HEADER 	OptionalHeader;
IMAGE_SECTION_HEADER   *SectionHeaders;     
_PeHeaderError 		PeHeaderError;
uint32			RealSizeOfHeaders;
static        char      *_PeHeaderErrorsMsg[];

public:
	PeHeader();			// Constructor
	~PeHeader();    		// Destructor
int     LoadHeader(const char* fname);  // Read header ;)
int     SaveHeader(const char *fname);  // Save pe header into pe image...

uint32  Rva2Lseek(uint32 Rva,int *num=0);          // RVA to abs. file pos
uint32  Tell2Rva(uint32  Pos,int *num=0);          // abs. file pos to RVA

IMAGE_DATA_DIRECTORY  *GetDirectory(uint DirNum); 
IMAGE_SECTION_HEADER  *GetSectionHeader(uint SecNum);
IMAGE_FILE_HEADER     *GetFileHeader();     
IMAGE_OPTIONAL_HEADER *GetOptionalHeader();

int PushSectionHeader(const IMAGE_SECTION_HEADER *SecHeader);
                                       // add section header
int PopSectionHeader();                // del last section header
uint32 GetRealSizeOfHeaders();         //

_PeHeaderError GetLastError() {return PeHeaderError;}	
const char* GetLastErrorText(){return _PeHeaderErrorsMsg[PeHeaderError];}
};
#endif